/***************************************************************************************************/
/*script in Sql, generate by SdmCreateScript 2020(by Qihang Feng, QF255001@TERADATA.COM)     */
/*VERSION 01.10 revised on 2020-08-25                                                              */
/*Brilliance stems from wisdoms.                                                                   */
/*************Head Section**************************************************************************/
/*Script Use: Periodically load data to :cust_chat_record_info(ccc客户会话记录信息)             */
/*Create Date:2024-10-25 17:45:11                                                                  */
/*SDM Developed By: dev                                                                            */
/*SDM Developed Date: 2024-08-14                                                                   */
/*SDM Checked By: dev                                                                              */
/*SDM Checked Date: 2024-10-25                                                                     */
/*Script Developed By: dev                                                                         */
/*Script Checked By: dev                                                                           */
/*Source table 1: :COMMDB.select replace(jsonb_array_elements(visitor_ids::jsonb)::text,'"','') as visitor_id ,row_number() over(partition by replace(jsonb_array_elements(visitor_ids::jsonb)::text,'"','') order by id desc) rn ,* from p30_common.d_ccc_cust_info dcci  
where visitor_ids <>''*/
/*Source table 2: :PDMDB.t01_livechat_record                                                       */
/*Source table 3: :PDMDB.t99_ccc_code                                                              */
/*Source table 4: :COMMDB.cust_chat_ccc_record                                                     */
/*Source table 5: :COMMDB.cust_leads_detail                                                        */
/*Job Type: Inbound transform (Tier 1 to Tier 2)                                                   */
/*Target Table:cust_chat_record_info                                                               */
/*ETL Job Name:cust_chat_record_info                                                               */
/*ETL Frequency:Daily                                                                              */
/*ETL Policy:F2                                                                                    */
/********************************************************************************************/
/*******Main Section**************************************************************************/
\set ON_ERROR_STOP on
\set AUTOCOMMIT on
\timing on



/*创建临时表加载当前数据                                                                           */
CREATE TEMPORARY TABLE cust_chat_record_info_agi_CUR_I 
 ( LIKE :MARTDB.cust_chat_record_info)
ON COMMIT PRESERVE ROWS;



/*创建临时表加载不同数据                                                                           */
CREATE TEMPORARY TABLE cust_chat_record_info_agi_INS 
( LIKE :MARTDB.cust_chat_record_info)
ON COMMIT PRESERVE ROWS;

            
/*****************************************************************************************************/
/* GROUP 1:Source Table:cust_chat_ccc_record**********************************************************/
/*****************************************************************************************************/

INSERT INTO cust_chat_record_info_agi_CUR_I (
            chat_unique_id                          /*在线客服会话ID*/
           ,chat_channel                            /*平台*/
           ,contact_channel                         /*接入渠道*/
           ,contact_app_id                          /*接入号ID*/
           ,app_name                                /*接入号名称*/
           ,group_name                              /*分组*/
           ,queue_name                              /*队列名称*/
           ,service_name                            /*服务*/
           ,start_time                              /*会话开始时间戳*/
           ,end_time                                /*会话结束时间戳*/
           ,chat_duration_in_seconds                /*会话持续时间*/
           ,queue_time                              /*排队时长*/
           ,referer_url                             /*来源页*/
           ,first_visit_page_url                    /*着陆页*/
           ,visitor_id                              /*访客ID*/
           ,visitor_name                            /*访客姓名*/
           ,visitor_mobile                          /*访客手机*/
           ,visitor_email                           /*访客邮箱*/
           ,visitor_company                         /*访客公司*/
           ,tag_1                                   /*标签1*/
           ,tag_2                                   /*标签2*/
           ,tag_3                                   /*标签3*/
           ,Etl_Batch_No                            /*作业批次号*/
           ,Etl_First_Dt                            /*最初入库时间*/
           ,Etl_Job                                 /*作业名称*/
           ,Etl_Proc_Dt                             /*本次入库时间*/
           ,Etl_Tx_Dt                               /*作业运行时间*/
           ,Src_Sysname                             /*来源系统*/
           ,Src_Table                               /*来源表*/
        )
SELECT
         COALESCE(TRIM(p0.chat_unique_id),'')                      /*chat_unique_id*/
        ,'Smart CCC'                                               /*chat_channel*/
        ,coalesce(p2.data_detail,'')                               /*contact_channel*/
        ,COALESCE(TRIM(p0.contact_app_id),'')                      /*contact_app_id*/
        ,COALESCE(TRIM(p0.app_name),'')                            /*app_name*/
        ,case when app_name ='TW官网' then 'TW' when app_name='CN官网' then 'CN' else '企微客服' end        /*group_name*/
        ,COALESCE(TRIM(CAST(p0.queue_name AS VARCHAR(100))),'')        /*queue_name*/
        ,case when p0.queue_name in ('选型报价','选型报价统计','TW销售服务','选型报价统计chat') then '产品报价'
      when p0.queue_name in ('售前技术','售后技术','技术支持统计','技术支持统计chat') then '技术支持'
      when p0.queue_name in ('保内维修','保外维修与计量','维修计量统计','维修计量统计chat') then '维修与校准'
      when p0.queue_name in ('其他咨询','其他支持统计','其他支持统计chat') then '其他'
      when p0.queue_name in ('Joe','Kuang_Chun','Lily','Susan','Tina_Zhang') then '其他'
      else '其他' end        /*service_name*/
        ,COALESCE(p0.start_time,TO_TIMESTAMP(:NULLDATE,'YYYYMMDD'))        /*start_time*/
        ,COALESCE(p0.end_time,TO_TIMESTAMP(:NULLDATE,'YYYYMMDD'))        /*end_time*/
        ,COALESCE(p0.chat_duration_in_seconds,0)                   /*chat_duration_in_seconds*/
        ,COALESCE(p0.queue_time,0)                                 /*queue_time*/
        ,COALESCE(TRIM(p0.referer_url),'')                         /*referer_url*/
        ,COALESCE(TRIM(p0.first_visit_page_url),'')                /*first_visit_page_url*/
        ,COALESCE(TRIM(p0.visitor_id),'')                          /*visitor_id*/
        ,coalesce(p1.name,'')                                      /*visitor_name*/
        ,coalesce(p1.tel,'')                                       /*visitor_mobile*/
        ,coalesce(p1.email,'')                                     /*visitor_email*/
        ,coalesce(p1.company,'')                                   /*visitor_company*/
        ,''                                                        /*tag_1*/
        ,''                                                        /*tag_2*/
        ,''                                                        /*tag_3*/
        ,0                                                         /*Etl_Batch_No*/
        ,TO_DATE(:TXDATE,'YYYYMMDD')                               /*Etl_First_Dt*/
        ,:ETLJOB                                                   /*Etl_Job*/
        ,current_timestamp(0)                                      /*Etl_Proc_Dt*/
        ,TO_DATE(:TXDATE,'YYYYMMDD')                               /*Etl_Tx_Dt*/
        ,Substr('cust_chat_ccc_record',1,3)                        /*Src_Sysname*/
        ,'cust_chat_ccc_record'                                    /*Src_Table*/
        
FROM :COMMDB.cust_chat_ccc_record  p0
LEFT JOIN (select replace(jsonb_array_elements(visitor_ids::jsonb)::text,'"','') as visitor_id ,row_number() over(partition by replace(jsonb_array_elements(visitor_ids::jsonb)::text,'"','') order by id desc) rn ,* from p30_common.d_ccc_cust_info dcci  
where visitor_ids <>'') p1
        ON p0 .visitor_id =p1 .visitor_id 
and p1.rn=1
LEFT JOIN :PDMDB.t99_ccc_code  p2
        ON p2.code_type ='chat_contact_channel'
and p0.contact_channel =p2.data_code 
where p0 .chat_duration_type not in ('9','')

;



/*****************************************************************************************************/
/* GROUP 2:Source Table:cust_leads_detail*************************************************************/
/*****************************************************************************************************/

INSERT INTO cust_chat_record_info_agi_CUR_I (
            chat_unique_id                          /*在线客服会话ID*/
           ,chat_channel                            /*平台*/
           ,contact_channel                         /*接入渠道*/
           ,contact_app_id                          /*接入号ID*/
           ,app_name                                /*接入号名称*/
           ,group_name                              /*分组*/
           ,queue_name                              /*队列名称*/
           ,service_name                            /*服务*/
           ,start_time                              /*会话开始时间戳*/
           ,end_time                                /*会话结束时间戳*/
           ,chat_duration_in_seconds                /*会话持续时间*/
           ,queue_time                              /*排队时长*/
           ,referer_url                             /*来源页*/
           ,first_visit_page_url                    /*着陆页*/
           ,visitor_id                              /*访客ID*/
           ,visitor_name                            /*访客姓名*/
           ,visitor_mobile                          /*访客手机*/
           ,visitor_email                           /*访客邮箱*/
           ,visitor_company                         /*访客公司*/
           ,tag_1                                   /*标签1*/
           ,tag_2                                   /*标签2*/
           ,tag_3                                   /*标签3*/
           ,Etl_Batch_No                            /*作业批次号*/
           ,Etl_First_Dt                            /*最初入库时间*/
           ,Etl_Job                                 /*作业名称*/
           ,Etl_Proc_Dt                             /*本次入库时间*/
           ,Etl_Tx_Dt                               /*作业运行时间*/
           ,Src_Sysname                             /*来源系统*/
           ,Src_Table                               /*来源表*/
        )
SELECT
         p0.contact_account                                        /*chat_unique_id*/
        ,'LiveChat'                                                /*chat_channel*/
        ,''                                                        /*contact_channel*/
        ,''                                                        /*contact_app_id*/
        ,p1.group_name                                             /*app_name*/
        ,case when p1.group_name like 'Tai%' then 'TW' when p1.group_name like '%China%' then 'CN' else p1.group_name end        /*group_name*/
        ,p1.pre_chat_service                                       /*queue_name*/
        ,p0."event"                                                /*service_name*/
        ,p1.chat_creation_time                                     /*start_time*/
        ,p1.chat_start_time + interval '1second' * p1.chat_duration        /*end_time*/
        ,p1.chat_duration                                          /*chat_duration_in_seconds*/
        ,p1.queue_duration                                         /*queue_time*/
        ,p1.chat_referrer_url                                      /*referer_url*/
        ,p1.chat_start_url                                         /*first_visit_page_url*/
        ,p1.visitor_livechat_id                                    /*visitor_id*/
        ,p1.pre_chat_name                                          /*visitor_name*/
        ,p1.pre_chat_contact                                       /*visitor_mobile*/
        ,p1.pre_chat_email                                         /*visitor_email*/
        ,p1.pre_chat_company                                       /*visitor_company*/
        ,p1.tag_1                                                  /*tag_1*/
        ,p1.tag_2                                                  /*tag_2*/
        ,p1.tag_3                                                  /*tag_3*/
        ,0                                                         /*Etl_Batch_No*/
        ,TO_DATE(:TXDATE,'YYYYMMDD')                               /*Etl_First_Dt*/
        ,:ETLJOB                                                   /*Etl_Job*/
        ,current_timestamp(0)                                      /*Etl_Proc_Dt*/
        ,TO_DATE(:TXDATE,'YYYYMMDD')                               /*Etl_Tx_Dt*/
        ,Substr('cust_leads_detail',1,3)                           /*Src_Sysname*/
        ,'cust_leads_detail'                                       /*Src_Table*/
        
FROM :COMMDB.cust_leads_detail  p0
LEFT JOIN :PDMDB.t01_livechat_record  p1
        ON p0.contact_account =p1.livechat_leads_id
where contact_channel ='Chat' and p1.visitor_country_code in ('CN','TW')

;



/*将不同数据插入到临时表                                                                           */
;INSERT INTO cust_chat_record_info_agi_INS (
         chat_channel                                              /*平台*/
        ,contact_channel                                           /*接入渠道*/
        ,contact_app_id                                            /*接入号ID*/
        ,app_name                                                  /*接入号名称*/
        ,group_name                                                /*分组*/
        ,queue_name                                                /*队列名称*/
        ,service_name                                              /*服务*/
        ,start_time                                                /*会话开始时间戳*/
        ,end_time                                                  /*会话结束时间戳*/
        ,chat_duration_in_seconds                                  /*会话持续时间*/
        ,queue_time                                                /*排队时长*/
        ,referer_url                                               /*来源页*/
        ,first_visit_page_url                                      /*着陆页*/
        ,visitor_id                                                /*访客ID*/
        ,visitor_name                                              /*访客姓名*/
        ,visitor_mobile                                            /*访客手机*/
        ,visitor_email                                             /*访客邮箱*/
        ,visitor_company                                           /*访客公司*/
        ,tag_1                                                     /*标签1*/
        ,tag_2                                                     /*标签2*/
        ,tag_3                                                     /*标签3*/
        ,chat_unique_id                                            /*在线客服会话ID*/
        ,Etl_Batch_No                                              /*作业批次号*/
        ,Etl_First_Dt                                              /*最初入库时间*/
        ,Etl_Job                                                   /*作业名称*/
        ,Etl_Proc_Dt                                               /*本次入库时间*/
        ,Etl_Tx_Dt                                                 /*作业运行时间*/
        ,Src_Sysname                                               /*来源系统*/
        ,Src_Table                                                 /*来源表*/
        
)
    SELECT
         P1.chat_channel                                              /*平台*/
        ,P1.contact_channel                                           /*接入渠道*/
        ,P1.contact_app_id                                            /*接入号ID*/
        ,P1.app_name                                                  /*接入号名称*/
        ,P1.group_name                                                /*分组*/
        ,P1.queue_name                                                /*队列名称*/
        ,P1.service_name                                              /*服务*/
        ,P1.start_time                                                /*会话开始时间戳*/
        ,P1.end_time                                                  /*会话结束时间戳*/
        ,P1.chat_duration_in_seconds                                  /*会话持续时间*/
        ,P1.queue_time                                                /*排队时长*/
        ,P1.referer_url                                               /*来源页*/
        ,P1.first_visit_page_url                                      /*着陆页*/
        ,P1.visitor_id                                                /*访客ID*/
        ,P1.visitor_name                                              /*访客姓名*/
        ,P1.visitor_mobile                                            /*访客手机*/
        ,P1.visitor_email                                             /*访客邮箱*/
        ,P1.visitor_company                                           /*访客公司*/
        ,P1.tag_1                                                     /*标签1*/
        ,P1.tag_2                                                     /*标签2*/
        ,P1.tag_3                                                     /*标签3*/
        ,P1.chat_unique_id                                            /*在线客服会话ID*/
        ,P1.Etl_Batch_No                                              /*作业批次号*/
        ,P1.Etl_First_Dt                                              /*最初入库时间*/
        ,P1.Etl_Job                                                   /*作业名称*/
        ,P1.Etl_Proc_Dt                                               /*本次入库时间*/
        ,P1.Etl_Tx_Dt                                                 /*作业运行时间*/
        ,P1.Src_Sysname                                               /*来源系统*/
        ,P1.Src_Table                                                 /*来源表*/
        
FROM cust_chat_record_info_agi_CUR_I P1
LEFT JOIN :MARTDB.cust_chat_record_info P2
ON    P1.chat_channel = P2.chat_channel
    AND P1.contact_channel = P2.contact_channel
    AND P1.contact_app_id = P2.contact_app_id
    AND P1.app_name = P2.app_name
    AND P1.group_name = P2.group_name
    AND P1.queue_name = P2.queue_name
    AND P1.service_name = P2.service_name
    AND P1.start_time = P2.start_time
    AND P1.end_time = P2.end_time
    AND P1.chat_duration_in_seconds = P2.chat_duration_in_seconds
    AND P1.queue_time = P2.queue_time
    AND P1.referer_url = P2.referer_url
    AND P1.first_visit_page_url = P2.first_visit_page_url
    AND P1.visitor_id = P2.visitor_id
    AND P1.visitor_name = P2.visitor_name
    AND P1.visitor_mobile = P2.visitor_mobile
    AND P1.visitor_email = P2.visitor_email
    AND P1.visitor_company = P2.visitor_company
    AND P1.tag_1 = P2.tag_1
    AND P1.tag_2 = P2.tag_2
    AND P1.tag_3 = P2.tag_3
    AND P1.chat_unique_id = P2.chat_unique_id
    
WHERE  P2.chat_channel IS NULL
    OR P2.contact_channel IS NULL
    OR P2.contact_app_id IS NULL
    OR P2.app_name IS NULL
    OR P2.group_name IS NULL
    OR P2.queue_name IS NULL
    OR P2.service_name IS NULL
    OR P2.start_time IS NULL
    OR P2.end_time IS NULL
    OR P2.chat_duration_in_seconds IS NULL
    OR P2.queue_time IS NULL
    OR P2.referer_url IS NULL
    OR P2.first_visit_page_url IS NULL
    OR P2.visitor_id IS NULL
    OR P2.visitor_name IS NULL
    OR P2.visitor_mobile IS NULL
    OR P2.visitor_email IS NULL
    OR P2.visitor_company IS NULL
    OR P2.tag_1 IS NULL
    OR P2.tag_2 IS NULL
    OR P2.tag_3 IS NULL
    OR P2.chat_unique_id IS NULL
    
; 
/*将新增数据插入到目标表                                                                           */
;INSERT INTO :MARTDB.cust_chat_record_info (
         chat_channel                                              /*平台*/
        ,contact_channel                                           /*接入渠道*/
        ,contact_app_id                                            /*接入号ID*/
        ,app_name                                                  /*接入号名称*/
        ,group_name                                                /*分组*/
        ,queue_name                                                /*队列名称*/
        ,service_name                                              /*服务*/
        ,start_time                                                /*会话开始时间戳*/
        ,end_time                                                  /*会话结束时间戳*/
        ,chat_duration_in_seconds                                  /*会话持续时间*/
        ,queue_time                                                /*排队时长*/
        ,referer_url                                               /*来源页*/
        ,first_visit_page_url                                      /*着陆页*/
        ,visitor_id                                                /*访客ID*/
        ,visitor_name                                              /*访客姓名*/
        ,visitor_mobile                                            /*访客手机*/
        ,visitor_email                                             /*访客邮箱*/
        ,visitor_company                                           /*访客公司*/
        ,tag_1                                                     /*标签1*/
        ,tag_2                                                     /*标签2*/
        ,tag_3                                                     /*标签3*/
        ,chat_unique_id                                            /*在线客服会话ID*/
        ,Etl_Batch_No                                              /*作业批次号*/
        ,Etl_First_Dt                                              /*最初入库时间*/
        ,Etl_Job                                                   /*作业名称*/
        ,Etl_Proc_Dt                                               /*本次入库时间*/
        ,Etl_Tx_Dt                                                 /*作业运行时间*/
        ,Src_Sysname                                               /*来源系统*/
        ,Src_Table                                                 /*来源表*/
        
)
SELECT
         P1.chat_channel                                              /*平台*/
        ,P1.contact_channel                                           /*接入渠道*/
        ,P1.contact_app_id                                            /*接入号ID*/
        ,P1.app_name                                                  /*接入号名称*/
        ,P1.group_name                                                /*分组*/
        ,P1.queue_name                                                /*队列名称*/
        ,P1.service_name                                              /*服务*/
        ,P1.start_time                                                /*会话开始时间戳*/
        ,P1.end_time                                                  /*会话结束时间戳*/
        ,P1.chat_duration_in_seconds                                  /*会话持续时间*/
        ,P1.queue_time                                                /*排队时长*/
        ,P1.referer_url                                               /*来源页*/
        ,P1.first_visit_page_url                                      /*着陆页*/
        ,P1.visitor_id                                                /*访客ID*/
        ,P1.visitor_name                                              /*访客姓名*/
        ,P1.visitor_mobile                                            /*访客手机*/
        ,P1.visitor_email                                             /*访客邮箱*/
        ,P1.visitor_company                                           /*访客公司*/
        ,P1.tag_1                                                     /*标签1*/
        ,P1.tag_2                                                     /*标签2*/
        ,P1.tag_3                                                     /*标签3*/
        ,P1.chat_unique_id                                            /*在线客服会话ID*/
        ,P1.Etl_Batch_No                                              /*作业批次号*/
        ,P1.Etl_First_Dt                                              /*最初入库时间*/
        ,P1.Etl_Job                                                   /*作业名称*/
        ,P1.Etl_Proc_Dt                                               /*本次入库时间*/
        ,P1.Etl_Tx_Dt                                                 /*作业运行时间*/
        ,P1.Src_Sysname                                               /*来源系统*/
        ,P1.Src_Table                                                 /*来源表*/
        
FROM cust_chat_record_info_agi_INS P1
ON CONFLICT ( chat_unique_id)
DO UPDATE SET
     chat_unique_id=excluded.chat_unique_id
    ,chat_channel=excluded.chat_channel
    ,contact_channel=excluded.contact_channel
    ,contact_app_id=excluded.contact_app_id
    ,app_name=excluded.app_name
    ,group_name=excluded.group_name
    ,queue_name=excluded.queue_name
    ,service_name=excluded.service_name
    ,start_time=excluded.start_time
    ,end_time=excluded.end_time
    ,chat_duration_in_seconds=excluded.chat_duration_in_seconds
    ,queue_time=excluded.queue_time
    ,referer_url=excluded.referer_url
    ,first_visit_page_url=excluded.first_visit_page_url
    ,visitor_id=excluded.visitor_id
    ,visitor_name=excluded.visitor_name
    ,visitor_mobile=excluded.visitor_mobile
    ,visitor_email=excluded.visitor_email
    ,visitor_company=excluded.visitor_company
    ,tag_1=excluded.tag_1
    ,tag_2=excluded.tag_2
    ,tag_3=excluded.tag_3
    ,Etl_Batch_No=excluded.Etl_Batch_No
    ,Etl_First_Dt=excluded.Etl_First_Dt
    ,Etl_Job=excluded.Etl_Job
    ,Etl_Proc_Dt=excluded.Etl_Proc_Dt
    ,Etl_Tx_Dt=excluded.Etl_Tx_Dt
    ,Src_Sysname=excluded.Src_Sysname
    ,Src_Table=excluded.Src_Table
    

;
/*****程序结束退出                                               */
\q

